---
title: ParentNode.append()
slug: Web/API/ParentNode/append
tags:
  - API
  - DOM
  - Method
  - Node
  - ParentNode
  - Reference
---
<p>{{APIRef("DOM")}}</p>

<p><span class="seoSummary">The <strong><code>ParentNode.append()</code></strong> method inserts a set of {{domxref("Node")}} objects or {{domxref("DOMString")}} objects after the last child of the <code>ParentNode</code>. </span>{{domxref("DOMString")}} objects are inserted as equivalent {{domxref("Text")}} nodes.</p>

<p>Differences from {{domxref("Node.appendChild()")}}:</p>

<ul>
 <li><code>ParentNode.append()</code> allows you to also append {{domxref("DOMString")}} objects, whereas <code>Node.appendChild()</code> only accepts {{domxref("Node")}} objects.</li>
 <li><code>ParentNode.append()</code> has no return value, whereas <code>Node.appendChild()</code> returns the appended {{domxref("Node")}} object.</li>
 <li><code>ParentNode.append()</code> can append several nodes and strings, whereas <code>Node.appendChild()</code> can only append one node.</li>
</ul>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">// [Throws, Unscopable]
ParentNode.append(...<var>nodesOrDOMStrings</var>) // returns undefined
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>nodesOrDOMStrings</code></dt>
 <dd>A set of {{domxref("Node")}} or {{domxref("DOMString")}} objects to insert.</dd>
</dl>

<h3 id="Exceptions">Exceptions</h3>

<ul>
 <li>{{domxref("HierarchyRequestError")}}: Node cannot be inserted at the specified point in the hierarchy.</li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Appending_an_element">Appending an element</h3>

<pre class="brush: js notranslate">let parent = document.createElement("div")
let p = document.createElement("p")
parent.append(p)

console.log(parent.childNodes) // NodeList [ &lt;p&gt; ]
</pre>

<h3 id="Appending_text">Appending text</h3>

<pre class="brush: js notranslate">let parent = document.createElement("div")
parent.append("Some text")

console.log(parent.textContent) // "Some text"</pre>

<h3 id="Appending_an_element_and_text">Appending an element and text</h3>

<pre class="brush: js notranslate">let parent = document.createElement("div")
let p = document.createElement("p")
parent.append("Some text", p)

console.log(parent.childNodes) // NodeList [ #text "Some text", &lt;p&gt; ]</pre>

<h3 id="ParentNode.append_is_unscopable">ParentNode.append() is unscopable</h3>

<p>The <code>append()</code> method is not scoped into the <code>with</code> statement. See {{jsxref("Symbol.unscopables")}} for more information.</p>

<pre class="brush: js notranslate">let parent = document.createElement("div")

with(parent) {
  append("foo")
}
// ReferenceError: append is not defined </pre>

<h2 id="Polyfill">Polyfill</h2>

<p>You can polyfill the <code>append() method</code> in Internet Explorer 9 and higher with the following code:</p>

<pre class="brush: js notranslate">// Source: https://github.com/jserz/js_piece/blob/master/DOM/ParentNode/append()/append().md
(function (arr) {
  arr.forEach(function (item) {
    if (item.hasOwnProperty('append')) {
      return;
    }
    Object.defineProperty(item, 'append', {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function append() {
        var argArr = Array.prototype.slice.call(arguments),
          docFrag = document.createDocumentFragment();

        argArr.forEach(function (argItem) {
          var isNode = argItem instanceof Node;
          docFrag.appendChild(isNode ? argItem : document.createTextNode(String(argItem)));
        });

        this.appendChild(docFrag);
      }
    });
  });
})([Element.prototype, Document.prototype, DocumentFragment.prototype]);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-parentnode-append', 'ParentNode.append()')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ParentNode.append")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("ParentNode")}} and {{domxref("ChildNode")}}</li>
 <li>{{domxref("ParentNode.prepend()")}}</li>
 <li>{{domxref("Node.appendChild()")}}</li>
 <li>{{domxref("ChildNode.after()")}}</li>
 <li>{{domxref("Element.insertAdjacentElement()")}}</li>
 <li>{{domxref("NodeList")}}</li>
</ul>
